### Create a vagrant machine ##########################
### Provider = VirtualBox / box = bento/ubuntu ########
#######################################################

Vagrant.configure("2") do |config|

  # Master Machine config
  config.vm.define "lead" do |m|
    m.vm.box="bento/ubuntu-20.04"
    m.vm.network "private_network", ip: "192.168.56.11"
    m.vm.provider "virtualbox" do |vb|
      vb.memory = "1024"
      vb.cpus = 2
      # Créer un volume de 4BG
      vb.customize ["createhd", "--filename", "volumes/lead.vdi", "--size",  4096]
      vb.customize ["storageattach", :id, "--storagectl", "SATA Controller", "--port",  1, "--device",  0, "--type", "hdd", "--medium", "volumes/lead.vdi"]
    end
    m.vm.synced_folder "./vm/master/html", "/vagrant"
    m.vm.provision "shell", path: "provisions/master_provision.sh"
  end

  # Nodes Machine Config
  (1..3).each do |i|
    config.vm.define "node#{i}" do |n|
      n.vm.box = "bento/ubuntu-20.04"
      n.vm.network "private_network", ip: "192.168.56.12#{i}"
      n.vm.provider "virtualbox" do |vb|
        vb.memory = "512"
        vb.cpus = 1
        # Créer un volume de 4BG
        vb.customize ["createhd", "--filename", "volumes/node#{i}.vdi", "--size",  4096]
        vb.customize ["storageattach", :id, "--storagectl", "SATA Controller", "--port",  1, "--device",  0, "--type", "hdd", "--medium", "volumes/node#{i}.vdi"]
      end
      n.vm.synced_folder "./vm/node#{i}/html", "/vagrant"
      n.vm.provision "shell", path: "provisions/node_provision.sh", args: [i.to_s]
    end
  end    
end
